stages:
  - build
  - test
  - security

variables:
  SONAR_SCANNER_VERSION: 4.6.2.2472

# Build the Node.js application
build:
  stage: build
  image: node:14
  script:
    - npm install

# Static Code Analysis with SonarQube
sonarqube-check:
  stage: security
  image: sonarsource/sonar-scanner-cli:latest
  script:
    - sonar-scanner -Dsonar.projectKey=$CI_PROJECT_NAME -Dsonar.sources=. -Dsonar.host.url=$SONAR_HOST_URL -Dsonar.login=$SONAR_TOKEN

# Dependency Scanning with OWASP Dependency-Check
dependency-check:
  stage: security
  image: owasp/dependency-check:latest
  script:
    - dependency-check.sh --project secure-web-app --scan . --format ALL

# Container Security with Trivy
trivy-scan:
  stage: security
  image: aquasec/trivy:latest
  script:
    - docker build -t secure-web-app .
    - trivy image --exit-code 0 --severity HIGH,CRITICAL secure-web-app

# Dynamic Application Security Testing with OWASP ZAP
zap-scan:
  stage: security
  image: owasp/zap2docker-stable:latest
  services:
    - name: docker:dind
  script:
    - docker run -d -p 3000:3000 secure-web-app
    - sleep 30 # Give the application time to start
    - docker run --rm -t owasp/zap2docker-stable zap-baseline.py -t http://host.docker.internal:3000 -r zap_report.html
  artifacts:
    paths:
      - zap_report.html
